<?PHP
require_once("includes.php");

// athentifizierung und berechtigungen etc....
$script_name = "Adressenscript_Import Start";
$mtime = explode(" ",microtime());
$starttime = $mtime[1] + $mtime[0];
$make_the_break = time() + (ini_get('max_execution_time') - 5); // abbruchzeit errechnen
$is_broken = 0; // wurde das Script durch einen Parameter unterbrochen..... 1=ja 0=nein

require_once("templates/head.tpl");

if($_SESSION['login'] != $config['is_logged_in'])
{
   no_access_allowed();
   require_once("templates/footer.tpl");
   exit;
}

if(!isset($_SESSION['db_name']) OR (!isset($_SESSION['ta_belle'])) OR ($_SESSION['save_is_set'] != $config['is_logged_in']))
{
    echo '<div id="main_no_hight">';
    echo $lng['config_missing'];
    echo '</div>';
}

else
{
    echo '<div id="main_no_hight">';
    echo $lng['ad_import_donotclose'];

    // Felder die importiert werden sollen
    if($_SESSION['reihenfolge'] == "")
    {
        $felder = explode(",",$_SESSION['reihe_vorher']);
    }

    else
    {
        $felder = explode(",",$_SESSION['reihenfolge']);
    }

    if(isset($_SESSION['startwert_import']) and ($_SESSION['startwert_import'] > 0))
    {
        $startwert = $_SESSION['startwert_import'];
    }

    else
    {
        $startwert = 0;
    }

    // beim ersten durchlauf tabelle leeren wenn eingestellt
    if($startwert == 0 and ($_SESSION['how_to_trunk'] == 1))
    {
        $sql_trunk = 'TRUNCATE `'.$_SESSION['db_name'].'`.`'.$_SESSION['ta_belle'];
        dbquery($sql_trunk);
    }

    // sql String erstellen, values werden später eingefügt
    if(!isset($_SESSION['impsql']) or ($_SESSION['impsql'] == "") or ($_GET['init'] == 1))
    {
        if($_SESSION['how_to_sql'] == 1)
        {
            $sql = 'INSERT INTO `'.$_SESSION['db_name'].'`.`'.$_SESSION['ta_belle'].'` (';
        }

        elseif($_SESSION['how_to_sql'] == 3)
        {
            $sql = 'INSERT IGNORE INTO `'.$_SESSION['db_name'].'`.`'.$_SESSION['ta_belle'].'` (';
        }

        elseif($_SESSION['how_to_sql'] == 4)
        {
            $sql = 'REPLACE INTO `'.$_SESSION['db_name'].'`.`'.$_SESSION['ta_belle'].'` (';
        }

        // NUR UPDATE
        else
        {
            $sql_update = 'UPDATE `'.$_SESSION['db_name'].'`.`'.$_SESSION['ta_belle'].'` SET ';
            $sql_where = ' WHERE ';
        }

/**
 *      Tabellenfelder auslesen und in $ergebnis speichern und sql query erstellen
 **/
        $sqla = 'SELECT * FROM `'.$_SESSION['ta_belle'].'` LIMIT 0,1';
        $ergebnis = myfetch_all($sqla);

        for($a = 0; $a < count($ergebnis[0]); $a++)
        {
            $sql.= '`'.$ergebnis[0][$a].'`';

            if($a < count($ergebnis[0]) -1)
            {
                $sql.= ', ';
            }
        }
        $sql.= ') VALUES (';
        $_SESSION['feldanzahl'] = count($ergebnis);
    }

/**
 *
 * Die Datei einlesen
 *
**/

    $file = myfile("./temp/ad_import.csv");


    if($_SESSION['how_to_key'] == 2)
    {
        // Keys abschalten
        $sql_enkey = 'ALTER TABLE `'.$_SESSION['ta_belle'].'` DISABLE KEYS';
        dbquery($sql_enkey);
        echo "<br><br>".$lng['imp_keyno']."<br>";
    }

    // es gibt eine Koppfzeile, die nicht importieren
    if($startwert == 0)
    {
        if($_SESSION['how_to_head'] == 1)
        {
            $startwert = 1;
        }
    }

    //    Importvalues setzen
    for($i = $startwert; $i < count($file); $i++)
    {
        if(trim($file[$i]) == "") continue;

        unset($werte); // Tabellenfelder für sql loeschen
        unset($anhang);// Values fuer sql loeschgen

        // sqlstatements auf Leer setzen
        $ausgabe = "";
        $where_bed = "";
        $update_bed = "";
        $neue_werte = array(); // statistik

        $piece = explode($_SESSION['trennzeichen'],$file[$i]);
        $keycounter = 1;

        for($a = 0; $a < count($felder); $a++)
        {
            // importfeld von allem Mist befreien
            $impfeld = trim($piece[$felder[$a]]);

            // NUR UPDATE     wenn feld primary key
            if($_SESSION['prikey'][$ergebnis[0][$a]] == $felder[$a] and ($_SESSION['how_to_sql'] == 2))
            {
                if(!is_numeric($impfeld))
                {
                    if($_SESSION['how_to_utf'] == 1)
                    {
                        $impfeld = utf8_encode($impfeld);
                    }

                    if($_SESSION['how_to_utf'] == 3)
                    {
                        $impfeld = utf8_decode($impfeld);
                    }

                    $where_bed.='`'.$ergebnis[0][$a].'` = \''.mysql_real_escape_string(make_sonder_umlaut($impfeld)).'\'';
                    // NUR UPDATE
                    if(count($_SESSION['prikey']) > $keycounter)
                    {
                        $where_bed.= ' AND ';
                    }
                    $keycounter++;
                }

                else
                {
                    $werte[$a] = '\''.$impfeld.'\'';
                    $where_bed.= '`'.$ergebnis[0][$a].'` = '.$werte[$a];
                    // NUR UPDATE
                    if($a < count($ergebnis[0]) -1  and ($a > 0))
                    {
                        $update_bed.= ', ';
                    }
                }
            }
            // wenn feld NICHT primary key oder kein UPDATE
            else
            {
                if(!is_numeric($impfeld))
                {
                    if($_SESSION['how_to_utf'] == 1)
                    {
                        $impfeld = utf8_encode($impfeld);
                    }

                    if($_SESSION['how_to_utf'] == 3)
                    {
                        $impfeld = utf8_decode($impfeld);
                    }

                    $werte[$a] = '\''.mysql_real_escape_string(make_sonder_umlaut($impfeld)).'\'';
                    // NUR UPDATE
                    $update_bed .= '`'.$ergebnis[0][$a].'` = '.$werte[$a];
                    if($a < count($ergebnis[0]) -1 and ($a > 0))
                    {
                        $update_bed.= ', ';
                    }
                }

                else
                {
                    $werte[$a] = '\''.$impfeld.'\'';
                    // NUR UPDATE
                    $update_bed .= '`'.$ergebnis[0][$a].'` = '.$werte[$a];
                    if($a < count($ergebnis[0]) -1 and ($a > 0))
                    {
                        $update_bed.= ', ';
                    }
                }
            }
            $neue_werte[] = $impfeld;
        }

    // NUR UPDATE
        if($_SESSION['how_to_sql'] == 2)
        {
            $ausgabe = $sql_update.$update_bed.$sql_where.$where_bed.';';
        }
    // INSERT, INSERT IGNORE UND REPLACE
        else
        {
            // nicht gewaehlte Importfelder bis zur Anzahl an Tabellenfelder mit Leer auffüllen
            $werte = array_pad($werte, count($ergebnis[0]) , '\'\'');
            $anhang = implode(",",$werte);
            $ausgabe = $sql.$anhang.');';
        }

// DEN SQL IMPORTBEFEHL AN DB SENDEN
        if(time() >= $make_the_break)
        {
            $is_broken = 1;
            $_SESSION['startwert_import'] = $i;
            break;
        }
// Query ausführen
        dbquery($ausgabe);
        if($query_error != "")
        {
           $towrite = time()."\t"."import\t".$query_error."\t".utf8_encode($ausgabe)."\n";
           myfwrite("log/.htimport_errorlog.log", $towrite, 'a');
        }
        else
        {
           // import logfile schreiben
           $towrite = time()."\t"."import\t\t".utf8_encode($ausgabe)."\n";
           myfwrite("log/.htimport.log", $towrite, 'a');
        }
    }

    if($_SESSION['how_to_key'] == 2)
    {
        // keys wieder einschalten
        $sql_enkey = 'ALTER TABLE `'.$_SESSION['ta_belle'].'` ENABLE KEYS';
        dbquery($sql_enkey);
        echo $lng['imp_keyyes']."<br>\n";
    }

    echo "</div>\n";

    if($is_broken == 1)
    {
        $_SESSION['protolog'] = $_SESSION['logbefore']; // logging zurücksetzen
        $_SESSION['startwert_import']." Lines done.....";

       ?>
       <meta http-equiv="refresh" content="3;URL=ad_uplstart.php">
       <?PHP
    }
    // Neustart zurücksetzen
    else
    {
        if($config['unlink_on_import'] == 1)
        {
            unlink("./temp/ad_import.csv");
        }
        // Für neuen Import Startwert auf 0 setzen und Fenster schliessen
        $_SESSION['startwert_import'] = 0;
        $_SESSION['protolog'] = $_SESSION['logbefore']; // logging zurücksetzen

        $link_to_main_script = "<body onload=\"javascript:void(opener.parent.location.href='index.php?init=1'); self.close()\"></body>";
        echo $link_to_main_script;
    }
}
require_once("templates/footer.tpl");
