<?PHP
/**
 * Funktionen fuer den Import
 *
 * (c) mn-portal.at
 *
 **/

function no_access_allowed()
{
    global $lng;

    echo "<div id=\"main_no_navi\">\n";
    echo "<p class=\"datensatz\">\n";
    echo $lng['no_access'];
    echo "\n</p>\n</div>\n";
}

function do_truncate()
{
    global $lng;

    if(isset($_GET['how_to_trunk']))
    {
        $_SESSION['how_to_trunk'] = $_GET['how_to_trunk'];
    }

    if(!isset($_SESSION['how_to_trunk']) or ($_SESSION['how_to_trunk'] == ""))
    {
        $_SESSION['how_to_trunk'] = 2;
    }

    if($_SESSION['how_to_trunk'] == 1)
    {
        $sel1 = ' selected';
        $sel2 = '';
    }
    else
    {
        $sel2 = ' selected';
        $sel1 = '';
    }

    $imp_keys = '<select onChange="formHandler(this)" class="selbox" title="TRUNCATE TABLE">';
    $imp_keys .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_trunk=2"'.$sel2.'>'.$lng['no'].'</option>'."\n";
    $imp_keys .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_trunk=1"'.$sel1.'>'.$lng['yes'].'</option>'."\n";
    $imp_keys .= '</select>';

    return $imp_keys;
}

function init_imp()
{
    unset($_SESSION['reihe_vorher']);
    unset($_SESSION['reihenfolge']);

    unset($_SESSION['ta_belle']);
    unset($_SESSION['tab_spalten_anz']);
}

function sel_database($dba)
{
    $seldb = '<select onChange="formHandler(this)" class="selbox">';
    $seldb .= '<option value="nichts">Datenbank wählen</option>'."\n";
    for($i = 0; $i < count($dba); $i++)
    {
      if($dba[$i] == @$_GET['dbank']) $selected = " selected";
      else $selected = "";
      $seldb .= '<option value="index.php?dbank='.$dba[$i].'"'.$selected.'>'.$dba[$i].'</option>'."\n";
    }
    $seldb.= '</select>';
    return $seldb;
}

// Tabellen auswaehlen
function sel_table($tabelle)
{
    if(isset($_GET['ta_belle']))
    {
        $_SESSION['ta_belle'] = $_GET['ta_belle'];
    }
    else
    {
        $_SESSION['ta_belle'] = $tabelle[1][0];
    }

    $seltable = '<select onChange="formHandler(this)" class="selbox">';
    for($i = 1; $i < count($tabelle); $i++)
    {
      if($tabelle[$i][0] == $_SESSION['ta_belle']) $selected = " selected";
      else $selected = "";
      $seltable .= '<option value="index.php?init=1&amp;ta_belle='.$tabelle[$i][0].'"'.$selected.'>'.$tabelle[$i][0].'</option>'."\n";
    }
    $seltable.= '</select>';
    return $seltable;
}

// Trannzeichen auswaehlen
function sel_separator()
{
    global $config;

    if(isset($_GET['separator']))
    {
        $_SESSION['separator'] = $_GET['separator'];
    }

    if(!isset($_SESSION['separator']) or ($_SESSION['separator'] == ""))
    {
        $_SESSION['separator'] = 'Tab';
        $_SESSION['trennzeichen'] = "\t";
    }

    $trenner = myfile("vars/trenner.var");

    $selsep = '<select onChange="formHandler(this)" class="selbox">';
    for($i = 0; $i < count($trenner); $i++)
    {
      $separator = explode($config['trenner'],$trenner[$i]);

      if(trim($separator[1]) == $_SESSION['separator']) $selected = " selected";
      else $selected = "";
      $selsep .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.trim($separator[1]).'"'.$selected.'>'.$separator[1].'</option>'."\n";
    }
    $selsep.= '</select>';
    return $selsep;
}

// Importtyp insert oder update festlegen
function sel_insupd()
{
    global $lng;

    if(isset($_GET['how_to_sql']))
    {
        $_SESSION['how_to_sql'] = $_GET['how_to_sql'];
    }

    if(!isset($_SESSION['how_to_sql']) or ($_SESSION['how_to_sql'] == ""))
    {
        $_SESSION['how_to_sql'] = 1;
    }

    if($_SESSION['how_to_sql'] == 1)
    {
        $sel1 = ' selected';
        $sel2 = '';
        $sel3 = '';
        $sel4 = '';
    }
    elseif($_SESSION['how_to_sql'] == 2)
    {
        $sel1 = '';
        $sel2 = ' selected';
        $sel3 = '';
        $sel4 = '';
    }
    elseif($_SESSION['how_to_sql'] == 3)
    {
        $sel1 = '';
        $sel2 = '';
        $sel3 = ' selected';
        $sel4 = '';
    }

    else
    {
        $sel1 = '';
        $sel2 = '';
        $sel3 = '';
        $sel4 = ' selected';
    }

    $imp_up_ins = '<select onChange="formHandler(this)" class="selbox" title="See MYSQL-Readme">';
    $imp_up_ins .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_sql=1"'.$sel1.'>'.$lng['imp_insert'].'</option>'."\n";
    $imp_up_ins .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_sql=2"'.$sel2.'>'.$lng['imp_update'].'</option>'."\n";
    $imp_up_ins .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_sql=3"'.$sel3.'>'.$lng['imp_insert_ignore'].'</option>'."\n";
    $imp_up_ins .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_sql=4"'.$sel4.'>'.$lng['imp_replace'].'</option>'."\n";
    $imp_up_ins .= '</select>';

    return $imp_up_ins;
}

function find_table_numrow()
{
    global $tabellennamen;

    $sql = 'SELECT * FROM `'.mysql_real_escape_string($_SESSION['ta_belle']).'`';
    $tabellennamen = get_field_names($sql); // Tebellen Spaltenbezeichnungen
    $_SESSION['tab_spalten_anz'] = count($tabellennamen);
}

function set_separator()
{
    global $config;

    $trenner = myfile("vars/trenner.var");
    for($i = 0; $i < count($trenner); $i++)
    {
        $seppeln = explode($config['trenner'],$trenner[$i]);
        if(trim($seppeln[1]) == $_SESSION['separator'])
        {
            $_SESSION['trennzeichen'] = $seppeln[0];
            break;
        }
    }
}

function sel_enkey()
{
    global $lng;

    if(isset($_GET['how_to_key']))
    {
        $_SESSION['how_to_key'] = $_GET['how_to_key'];
    }

    if(!isset($_SESSION['how_to_key']) or ($_SESSION['how_to_key'] == ""))
    {
        $_SESSION['how_to_key'] = 1;
    }

    if($_SESSION['how_to_key'] == 1)
    {
        $sel1 = ' selected';
        $sel2 = '';
    }
    else
    {
        $sel2 = ' selected';
        $sel1 = '';
    }

    $imp_keys = '<select onChange="formHandler(this)" class="selbox" title="Enable/Disable Primary Keys">';
    $imp_keys .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_key=1"'.$sel1.'>'.$lng['imp_en_key'].'</option>'."\n";
    $imp_keys .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_key=2"'.$sel2.'>'.$lng['imp_dis_key'].'</option>'."\n";
    $imp_keys .= '</select>';

    return $imp_keys;
}

function is_header()
{
    global $lng;

    if(isset($_GET['how_to_head']))
    {
        $_SESSION['how_to_head'] = $_GET['how_to_head'];
    }

    if(!isset($_SESSION['how_to_head']) or ($_SESSION['how_to_head'] == ""))
    {
        $_SESSION['how_to_head'] = 1;
    }

    if($_SESSION['how_to_head'] == 1)
    {
        $sel1 = ' selected';
        $sel2 = '';
    }
    else
    {
        $sel2 = ' selected';
        $sel1 = '';
    }

    $imp_head = '<select onChange="formHandler(this)" class="selbox">';
    $imp_head .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_head=1"'.$sel1.'>'.$lng['imp_is_head'].'</option>'."\n";
    $imp_head .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_head=2"'.$sel2.'>'.$lng['imp_is_nohead'].'</option>'."\n";
    $imp_head .= '</select>';

    return $imp_head;
}


function is_utf()
{
    global $lng;

    if(isset($_GET['how_to_utf']))
    {
        $_SESSION['how_to_utf'] = $_GET['how_to_utf'];
    }

    if(!isset($_SESSION['how_to_utf']) or ($_SESSION['how_to_utf'] == ""))
    {
        $_SESSION['how_to_utf'] = 2; // nichts de/encoden
    }

    if($_SESSION['how_to_utf'] == 1)
    {
        $sel1 = ' selected';
        $sel2 = '';
        $sel3 = '';
    }

    elseif($_SESSION['how_to_utf'] == 2)
    {
        $sel1 = '';
        $sel2 = ' selected';
        $sel3 = '';
    }

    else
    {
        $sel1 = '';
        $sel2 = '';
        $sel3 = ' selected';
    }

    $imp_head = '<select onChange="formHandler(this)" class="selbox">';
    $imp_head .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_utf=1"'.$sel1.'>'.$lng['imp_is_utf'].'</option>'."\n";
    $imp_head .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_utf=3"'.$sel3.'>'.$lng['imp_is_utfdec'].'</option>'."\n";
    $imp_head .= '<option value="index.php?ta_belle='.$_SESSION['ta_belle'].'&amp;separator='.$_SESSION['separator'].'&amp;how_to_utf=2"'.$sel2.'>'.$lng['imp_is_noutf'].'</option>'."\n";
    $imp_head .= '</select>';

    return $imp_head;
}

// daten in file schreiben
function myfwrite($file,$towrite,$mode)
{
   global $cache, $file_counter, $config;

   $set_chmod = 0;

   if(!myfile_exists($file)) $set_chmod = 1;
   $fp = fopen($config['basedir'].$file,$mode.'b') or die("fopen file error...!");

   flock($fp,LOCK_EX);
   if(!is_array($towrite))
   {
      fwrite($fp,$towrite);
   }
   else
   {
      for($i = 0; $i < sizeof($towrite); $i++)
      {
         fwrite($fp,$towrite[$i]);
      }
   }

   flock($fp,LOCK_UN); fclose($fp);
   if($set_chmod == 1)
   {
      @chmod($config['basedir'].$file,0777);
   }
   if($mode == "w") $cache['files'][$file] = $towrite;
   else
   {
      $file_counter++;
      $cache['files'][$file] = @file($config['basedir'].$file);
   }
}

// ist eine datei vorhanden ?
function myfile_exists($file)
{
   global $config, $cache;
   return file_exists($config['basedir'].$file);
}

// file/cache auslesen und zurueckgeben
function myfile($file)
{
   global $file_counter, $cache, $config;

   if(!isset($cache['files'][$file]))
   {
      $cache['files'][$file] = @file($config['basedir'].$file);
      $file_counter++;
   }
   return $cache['files'][$file];
}

// zur datenbank connecten oder fehler ausgeben
function dbconnect($db_host, $db_user, $db_pass, $db_name)
{
   global $startsqltime;

   $mtime = explode(" ",microtime());
   $startsqltime = $mtime[1] + $mtime[0];

   $db_connect = @mysql_connect($db_host, $db_user, $db_pass);
   $db_select = @mysql_select_db($db_name);
   if (!$db_connect)
   {
      die("<div style='font-family:Verdana;font-size:11px;text-align:center;'><b>Unable to establish connection to MySQL</b><br>".mysql_errno()." : ".mysql_error()."</div>");
   }

   elseif (!$db_select)
   {
      die("<div style='font-family:Verdana;font-size:11px;text-align:center;'><b>Unable to select MySQL database</b><br>".mysql_errno()." : ".mysql_error()."</div>");
   }
}

// query absetzen, gegebenenfalls fehlermeldung zurueckgeben
function dbquery($query)
{
   global $query_error,$startsqltime, $sqltime;

   $query_error = '';

   $result = @mysql_query($query);

   if (!$result)
   {
      $query_error = "(".mysql_errno().")".mysql_error();
      $towrite = time()."\t"."query\t".$query_error."\t".utf8_encode($query)."\n";
      myfwrite("log/.hterrorlog.log", $towrite, 'a');
      return false;
   }
   else
   {
      sql_ende();
      return $result;
   }
}

// alle daten einer abfrage in ein array laden...
function myfetch_all($sql)
{
   global $query_error, $startsqltime, $sqltime;

   $result = dbquery($sql);
   if(!$result)
   {
      return false;
   }

   $x = 1;
   // array 0 ist feldname...
   for($r = 0; $r < mysql_num_fields($result); $r++)
   {
      $ergebnis[0][$r] = mysql_field_name($result,$r);
   }

   // ab arry 1 werden die daten gelesen
   while ($row = mysql_fetch_row($result))
   {
      for($a = 0; $a < mysql_num_fields($result); $a++)
      {
         $ergebnis[$x][$a] = my_utf8($row[$a]);
      }
      $x++;
   }

   sql_ende();
   return $ergebnis;
}


// Laufzeit SQL ermitteln
function sql_ende()
{
   global $startsqltime, $sqltime;

   $mtime = explode(" ",microtime());
   $mtime = $mtime[1] + $mtime[0];
   $sqltime = round($mtime-$startsqltime,6);
}

function get_field_names($sql, $how=0)
{
   global $query_error, $startsqltime, $sqltime;

   if(!stristr($sql,"LIMIT"))
   {
        $sql .= ' LIMIT 1';
   }

   $result = dbquery($sql);
   // array 0 ist feldname...

   for($r = 0; $r < mysql_num_fields($result); $r++)
   {
      if($how == 0)
      {
         $ergebnis[$r] = mysql_field_name($result,$r);
      }

      else
      {
         $ergebnis[0][$r] = mysql_field_name($result,$r);
      }
   }
   sql_ende();
   return $ergebnis;
}


function my_utf8($string)
{
   global $config;
   if($config['use_utf8'] == 1)
   {
      $string = utf8_encode($string);
   }

   if(!isset($_SESSION['insert_brake'])) $_SESSION['insert_brake'] = 0;
   if($_SESSION['insert_brake'] == 1)
   {
      $string = str_replace("\n","<br>",$string);
   }

   return $string;
}

function make_my_form($action,$target,$mode,$buchstabe,$loggin,$seite,$sort,$bttnvalue,$bttnclass="button")
{
   if($action == "")
   {
      $action = $_SERVER['PHP_SELF'];
   }

   if($loggin != "")
   {
      $loggin = '?bstab='.$loggin;
   }

   if($mode == "")
   {
      $loggin .= '&amp;aktion='.$_SESSION['aktion'];
   }

   if($target != "")
   {
       $target = 'target="'.$target.'" ';
   }

   if(isset($_SESSION['orientation']) and ($_SESSION['orientation'] != ""))
   {
      echo '<div class="'.$_SESSION['orientation'].'">'."\n".'<a href="'.$action.$loggin.'" '.$target.'class="'.$bttnclass.'"><span>'.$bttnvalue."</span></a>\n</div>\n";
   }
   else
   {
      echo ' <a href="'.$action.$loggin.'" '.$target.'class="'.$bttnclass.'"><span>'.$bttnvalue.'</span></a>'."\n";
   }
}

function preview($var)
{
   echo "<br><pre>";
   print_r($var);
   echo "</pre><br>";
}

// farben wechseln
function change_color($color)
{
   switch($color)
   {
      case "td2ov":
      $color = "td1ov";
      break;

      default:
      $color = "td2ov";
      break;
   }
   return $color;
}

function demutate($text)
{
   $text = str_replace("&ouml;","ö",$text);
   $text = str_replace("&auml;","ä",$text);
   $text = str_replace("&uuml;","ü",$text);
   $text = str_replace("&Ouml;","Ö",$text);
   $text = str_replace("&Auml;","Ä",$text);
   $text = str_replace("&Uuml;","Ü",$text);
   $text = str_replace("&szlig;","ß",$text);
   $text = str_replace("&nbsp;"," ",$text);
   $text = str_replace("&nbsp;"," ",$text);
   $text = str_replace("\r","",$text);
   $text = str_replace("\n","",$text);

   return $text;
}


function make_sonder_umlaut($text)
{
   $text = str_replace("ö","&ouml;",$text);
   $text = str_replace("ä","&auml;",$text);
   $text = str_replace("ü","&uuml;",$text);
   $text = str_replace("Ö","&Ouml;",$text);
   $text = str_replace("Ä","&Auml;",$text);
   $text = str_replace("Ü","&Uuml;",$text);
   $text = str_replace("ß","&szlig;",$text);
   return $text;
}

function clean($text)
{
   $text = str_replace("\r","",$text);
   $text = str_replace("\n","",$text);
   return $text;
}

function show_trenner()
{
    echo '<pre>';
    echo $_SESSION['separator']." -> ".$_SESSION['trennzeichen'];
    echo '</pre>';
}
