<?PHP
require_once("includes.php"); // sql-functionen aufrufen

if($_SESSION['login'] != $config['is_logged_in'])
{
    no_access_allowed();
    exit;
}

if(!isset($_SESSION['db_name']))
{
    echo "keine datenbank da";
}

else
{
    $sql = 'SELECT * FROM `'.$_SESSION['ta_belle'].'`';
    $tabellennamen = get_field_names($sql); // Tebellen Spaltenbezeichnungen

    $sql = 'DESCRIBE '.$_SESSION['ta_belle'];
    $besch = myfetch_all($sql);

//    preview($besch);

// primary Key herausfinden und in session pri setzen, index in prikey setzen
    unset($_SESSION['pri']); // altes Zeug loeschen
    unset($_SESSION['prikey']); // altes Zeug loeschen
    for($i = 1; $i < count($besch); $i++)
    {
        if($besch[$i][3] == 'PRI')
        {
            $_SESSION['pri'][$besch[$i][0]] = $besch[$i][5];
            $_SESSION['prikey'][$besch[$i][0]] = ($i - 1);
        }
    }

    if(isset($_GET['l']))
    {
        foreach ($_GET['l'] as $position => $item)
        {
            $sort[] = $item;
            $_SESSION['reihenfolge'] = implode(",",$sort);
        }
    }

    if(isset($_SESSION['reihenfolge']))
    {
        $waswo = explode(",",$_SESSION['reihenfolge']);
    }

    else
    {
        $waswo = explode(",",$_SESSION['reihe_vorher']);
    }

    $file = myfile("temp/ad_import.csv");
    $colorh = "thsmall";

    $tbodyflag = 0;

    echo "<table class=\"tbl\">\n";

    echo "<tr>\n";
    // Tabellen Spalten übersetzen oder SQL-Namen ausgeben
    for($i = 0; $i < count($tabellennamen); $i++)
    {
        $title = "";
        if(isset($lng[$tabellennamen[$i]]))
        {
            $hedtitle = $lng[$tabellennamen[$i]];
        }
        else
        {
            $hedtitle = $tabellennamen[$i];
        }

        // Primary Key markieren
        if(isset($_SESSION['pri'][$tabellennamen[$i]]))
        {
            $color = 'tddetailmust';
            $title = 'Primary Key';
        }
        else
        {
            $color = $colorh;
        }

        echo " <td class=\"".$color."\" title=\"".$title."\">".$hedtitle."</td>\n";
    }
    $tbodyflag = 1;

    echo "</tr>\n";
    $color = change_color($color);

    if($_SESSION['how_to_head'] == 1)
    {
        $startwert = 1;
    }

    else
    {
        $startwert = 0;
    }

    // maximal 100 Zeilen für Vorschau
    $ende = count($file);
    if(count($file) > $config['list_preview'])
    {
        $ende = ($config['list_preview'] + 1);
    }

    for($w = $startwert; $w < $ende; $w++)
    {
        if($tbodyflag == 1)
        {
            echo "<tbody style=\"height:100px; overflow: auto;\">";
            $tbodyflag = 2;
        }

        $wert = @explode($_SESSION['trennzeichen'],$file[$w]);
        // anzahl import-felder auf anzahl tabellenspalten der adresstabelle festlegen
        $werte = @array_pad($wert,count($tabellennamen) , "");

        echo "<tr>\n";
        for($i = 0; $i < count($tabellennamen); $i++)
        {
            $werte[$waswo[$i]] = trim($werte[$waswo[$i]]);
            if($_SESSION['how_to_utf'] == 1)
            {
               $werte[$waswo[$i]] = utf8_encode($werte[$waswo[$i]]);
            }

            if($_SESSION['how_to_utf'] == 3)
            {
               $werte[$waswo[$i]] = utf8_decode($werte[$waswo[$i]]);
            }
            echo " <td class=\"".$color."\">".my_utf8(mysql_real_escape_string($werte[$waswo[$i]]))."</td>\n";
        }
        echo "</tr>\n";
        $color = change_color($color);
    }
    echo "</tbody>\n</table>\n";
}
