<?PHP

// athentifizierung und berechtigungen etc....
chdir("../"); // ins stammverzeichnis wechseln

require_once("includes.php");
// highlight der Anzeige laden
require_once("logview/config.php");

$config['stylesheet'] = "../".$config['stylesheet']; // style-pfad anpassen

if($_SESSION['login'] != $config['is_logged_in'])
{
    no_access_allowed();
    exit;
}
else
{
    include("templates/head.tpl");

    function echolog($path)
    {
    $check = array();
    if(!file_exists($path))
    {
        return FALSE;
    }

    $dir = dir($path);

    while(false !== ($file = $dir->read()))
    {
        if(("."  == $file) OR (".." == $file) OR (".htaccess" == $file) or(is_dir($path."/".$file) == TRUE))
        {
        continue;
        }
        else
        {
            $check[] = $file;
        }
       }
       $dir->close();

       if(count($check) > 0)
       {
            sort($check);
       }
       return $check;
    }

    function high_light($text,$words,$decode=1)
    {
       global $config;

       $text = str_replace('\"','"',$text);
       if($words == "") return $text;

       $words = explode(',',$words); //
       $color = myfile("logview/highlight.var",1);

      for($i = 0; $i < sizeof($words); $i++)
       {
            if($words[$i] == "" or ($words[$i] == " ")) continue;

            if($config['use_utf8_highlight'] == 1 and ($decode == 1))
            {
              $s = utf8_decode($words[$i]);
            }

            else
            {
              $s = $words[$i];
            }

            if(!stristr($text,$s)) continue;
            $t = $text;

            if(stristr($s,"/"))
            {
                $s = str_replace("/","\/",$s);
            }

            $c = $color[$i];
            // $text = @preg_replace("/((<[^>]*)|$s)/ie", '"\2"=="\1"? "\1":"<span style=\"background-color: #$c\">\1</span>"', $t);
            $text = str_ireplace($words[$i],"<span style=\"background-color: #$c\">".$words[$i]."</span>",$text);
       }

       $text = str_replace("\\","",$text);
       return $text;
    }

    ?>
       <script type="text/javascript">
       function formHandler(sel)
       {
      var sURL = sel.options[sel.selectedIndex].value;
      if (sURL != "nichts")
      {
      this.location.href= sURL;
      }
     }
       </script>

    <?PHP

    if(!isset($_GET['file'])) $_GET['file'] = '';
    if(!isset($_GET['logfile'])) $_GET['logfile'] = '';

    unset($logfiles);
    $logfiles = array();

    $date_color = 'blue';

    $dateconvert = 0;
    $dateformat = 0;
    $date_time = 1;
    $words = implode(",",$highlight['error']);
    $logpath = "./log";
    $logfiles = echolog($logpath);
    $words = implode(",",$highlight['error']);

    if(isset($_POST['highlight']) and ($_POST['highlight'] != ""))
    {
        $words = $_POST['highlight'];
    }

    if($_GET['file'] != '' and (isset($reverse[$_GET['file']]) AND ($reverse[$_GET['file']] == 1)))
    {
        if(count($logfiles) > 1) $logfiles = array_reverse($logfiles); // Dateireihenfolge umkehren (neuestes als erstes)
    }

    echo '<div id="main_no_hight">';
    echo $lng['admin_logview']."<br>\n<br>\n";

    echo $select;

    if(count($logfiles) >=1)
    {
        $sel = "<select onChange=\"formHandler(this)\" class=\"selbox\" title=\"Logs\">\n";
        $sel .= '<option value="ad_logview.php?file=error&amp;logfile=---"'; if($_GET['logfile'] == '---') { $sel.= ' selected'; }  $sel .='>---</option>'."\n";

        for($log = 0; $log < count($logfiles); $log ++)
        {
            if ($dateconvert == 1)
            {
        // Cron und Mail werden monatlich geloggt
        if($dateformat == 1)
        {
            $name = substr($logfiles[$log],7,2).".".substr($logfiles[$log],3,4);
        }
        // alle anderen täglich
        else
        {
            $name = substr($logfiles[$log],9,2).".".substr($logfiles[$log],7,2).".".substr($logfiles[$log],3,4);
        }
            }
            else
            {
                $name = $logfiles[$log];
            }

            $sel .= '<option value="ad_logview.php?file=error&amp;logfile='.$logfiles[$log].'"';
            if($_GET['logfile'] == $logfiles[$log])
            {
                $sel.= ' selected';
            }
            $sel .='>'.$name.'</option>'."\n";
        }
        $sel .= '</select>'."\n";

        echo $sel;

        echo '<div style="float:right;">';
        echo '<form method="POST" action="ad_logview.php?file=error&amp;logfile='.$_GET['logfile'].'">';
        echo 'Highlight: <input type="text" class="text" name="highlight" value="'.$words.'" size="70">&nbsp;&nbsp;&nbsp;&nbsp;';
        echo '&nbsp;<input type="submit" class="buttons" name="update" value="'.$lng['refresh'].'">';
        echo '</form></div>';
    }

    if(file_exists($logpath."/".$_GET['logfile'])) $ausgabe = myfile($logpath."/".$_GET['logfile']);

    if($_GET['file'] != '' and ($_GET['logfile'] != '---') and (isset($re_verse[$_GET['file']]) AND ($re_verse[$_GET['file']] == 1)))
    {
        $ausgabe = array_reverse($ausgabe);
    }

    echo "<br>\n<br>\n<div style=\"overflow:auto; height:380px; border: 1px dotted silver; padding:10px;\">\n";

    for($i = 0; $i < count($ausgabe); $i++)
    {
    if($date_time == 1)
    {
        $piece = explode("\t",$ausgabe[$i]);
        $piece[0] = trim($piece[0]);

        if(is_numeric($piece[0]) and strlen($piece[0]) == 10)
        {
        $piece[0] = '<b><span style=\"color:'.$date_color.';\">['.date($config['date_format_long'],$piece[0])."]</span></b>";
        if($_GET['file'] == 'backup')
        {
            if(stristr($ausgabe[$i],"<"))
            {
            $piece[0] .= '&nbsp;<span style="color:red;"><b>Restore</b></span>&nbsp;';
            }
            else
            {
            $piece[0] .= '&nbsp;<span style="color:green;"><b>Backup</b></span>&nbsp;';
            }
        }
        $ausgabe[$i] = implode("\t",$piece);
        }
    }
        echo '<span style="white-space: nowrap;">'.trim(high_light($ausgabe[$i],$words,$de_code[$_GET['file']]))."</span><br>\n";
    }

    echo "</div>\n";
    if($_GET['logfile'] != "")
    {
    ?><br><a name="clean" class="navbutton_nowidth" onclick="window.open('ad_loelogs.php?file=error&amp;logfile=<?PHP echo $_GET['logfile']; ?>', 'backup','width=20, height=20,top=<?PHP echo ($config['admin_top']+80); ?>,left=<?PHP echo ($config['admin_left']+80); ?>,scrollbars=<?PHP echo $config['admin_scroll']; ?>')"><?PHP echo $lng['delete']; ?></a><br>&nbsp;<?PHP
    }
    echo "</div>\n";
    if($config['stats'] == 1) require_once("templates/stats.tpl");
    include("templates/footer.tpl");
}
